#include <linux/config.h>
#include <net/ip_vs.h>

#ifndef _IP_VS_CB_H
#define _IP_VS_CB_H

#ifdef __KERNEL__

#define CONFIG_IP_MASQUERADE_VS_CS 1

extern __u32 (*rule_matching)(struct sk_buff *skb);
#define IP_VS_CB_MSG(msg...) printk(KERN_INFO "MYCS: " ## msg )
#define IP_VS_CB_MSG2(msg...)  /* ## msg */

/****
#define IP_VS_CB_PROF(msg...) printk(KERN_EMERG "CSPROFILE: " ## msg )
****/

#define  IP_MASQ_F_VS_CB_RSLOOSE        0x01  /* Real server not chosen */
#define  IP_MASQ_F_VS_CB_RSNOTREADY     0x02  /* Real server chosen but not ready*/
#define  IP_MASQ_F_VS_CB_RSREADY        0x04  /* Real server chosen and ready*/
#define  IP_MASQ_F_VS_CB_CLI_DATA_FWD   0x08  /* Flag to denote data came from local IP stack*/

/*
#define  IP_MASQ_F_VS_CB_SYN_SENT       0x10   State that represents SYN sent to RS 
#define  IP_MASQ_F_VS_CB_ACK_SENT       0x20   State that represents ACK sent to RS 
                                               after receipt of its SYN ACK 
*/

/*
#define  IP_MASQ_F_VS_CB_PARTIAL        0x1   
#define  IP_MASQ_F_VS_CB_COMPLETE       0x2  
*/

extern struct ip_masq *ip_masq_new_vs_cb(struct ip_vs_service *svc, struct sk_buff *skb);

extern int ip_vs_cb_schedule(struct ip_masq *ms, struct ip_vs_service *svc, struct sk_buff *skb);

extern int ip_vs_cb_send_client_ack(struct ip_masq *ms, struct sk_buff  *skb);

extern void ip_vs_cb_dequeue_client_pkt(struct ip_masq *ms, struct sk_buff  **skb_p);

extern void ip_vs_cb_send_client_rst(struct sk_buff  *skb);

extern void ip_vs_cb_fix_cli_ack_seq (struct ip_masq  *ms, struct sk_buff **skb_p);

extern void ip_vs_cb_get_server_seq(struct ip_masq  *ms, struct sk_buff *skb);

extern void ip_vs_cb_fix_svr_dat_seq(struct ip_masq *ms, struct sk_buff **skb_p);

extern struct sk_buff*  skb_concat(struct sk_buff_head *h, int newskb_len, __u16 whence);

extern struct ip_vs_dest *ip_vs_cb_dest_lookup(struct ip_vs_service *service, __u32 addr);

extern int ip_vs_cb_init(void);

extern __u32 ip_cs_norule(struct sk_buff *skb);

extern int ip_vs_cb_clean_cs_sock(struct ip_masq *ms, struct sk_buff  *skb);
extern void ip_vs_cb_init_masq(struct ip_masq *ms, struct sk_buff *skb);

#endif

#endif
