#ifndef  _IP_RULE_MATCH_H_
#define  _IP_RULE_MATCH_H_

#include <linux/config.h>

/*#define IP_RULE_MSG(msg...) printk(KERN_ALERT "RULE: " ## msg ) */

#define IP_RULE_MSG(msg...) /* ## msg */

#define   CR  '\r'
#define   LF  '\n'
#define   CRLF  "\r\n"
#define   CRLFCRLF  "\r\n\r\n"

/*
 * xml-uuencoded characters
 */
#define  UE_CR "%0D"      /* Carriage Return '\r' */
#define  UE_LF "%0A"      /* Line Feed '\n' */
#define  UE_SP "+"        /* Space char ' ' */
#define  UE_LA "%3C"      /* Left Anchor '<' */
#define  UE_RA "%3E"      /* Right Anchor '>' */
#define  UE_FS "%2F"      /* forward slash '/' */
#define  UE_EX "%21"      /* exclamation '!' '/' */

/*
 * text/xml plain characters
 */
#define  PL_CR "\r"      /* Carriage Return '\r' */
#define  PL_LF "\n"      /* Line Feed '\n' */
#define  PL_SP " "       /* Space char ' ' */
#define  PL_LA "<"       /* Left Anchor '<' */
#define  PL_RA ">"       /* Right Anchor '>' */
#define  PL_FS "/"       /* forward slash '/' */
#define  PL_EX "!"      /* exclamation '!' '/' */

#define STICKY_ON_IP 1
#define STICKY_ON_IP_PORT 2
#define NON_STICKY 3

struct server 
{
  char *name;
  __u32 addr;
};

struct ip_sticky
{
  __u32 source_ip;
  __u32 dest_ip;
};

struct ip_vs_cb_rule_field
{
  char  name[512];
  char  value[256];
};

extern __u32 route_to(char * name, int flag, __u32 saddr);
extern __u32 rule_configure(__u32 saddr, __u32 daddr, __u16 sport, __u16 dport, __u8 protocol);

extern char     url[];

#endif
