#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/malloc.h>
#include <linux/mm.h>
#include <linux/string.h>
#include <net/ip_masq.h>
#include <net/ip_mycs.h>
#include <net/rule_match.h>

/* 
   client domain vs. ipaddress
   wetterhorn     80c6a2d9,
   redcloud       80c6a242,
   cs             80c6a244,
   shavano        80c6a240,
   crestone       80c6a23d,
   sanluis        80c6a23e,
   blanca         80c6a23c,
*/

/*
struct ip_vs_cb_rule_field rule_fields [] =                                    
{                                                                              
  {"purchase:1.totalAmount:1.",  ""},
  {"purchase:1.item:2.subTotal:1.", ""},
  {"purchase:1.item:1.productID:1.", ""},
  {"purchase:1.item:2.productID:1.", ""},
  {"purchase:2.totalAmount:1.",  ""},
  {"purchase:2.item:2.subTotal:1.", ""},
  {"purchase:2.item:1.productID:1.", ""}
};                                                                             

struct ip_vs_cb_rule_field rule_fields [] =                                    
{                                                                              
  {"purchase:1.totalAmount:1.",  ""},
  {"purchase:1.item:2.subTotal:1.", ""},
  {"purchase:1.item:1.productID:1.", ""}
};                                                                             
*/

struct ip_vs_cb_rule_field rule_fields [] =
{
  {"purchase:1.totalAmount:1.", ""},
  {"purchase:1.item:2.subTotal:1.", ""}
};

int num_rule_fields = sizeof(rule_fields) / sizeof(struct ip_vs_cb_rule_field);

#define atoi(arg) simple_strtol(&(arg[0]), (char **) NULL, 10)

__u32 rule_configure( __u32 saddr, __u32 daddr, __u16 sport, __u16 dport, __u8 protocol)
{

R4:	if(atoi(rule_fields[1].value) >= 50000)
        {
          return route_to("ace", NON_STICKY, saddr);
	}

R5:	if((atoi(rule_fields[1].value) > 0) &&
           (atoi(rule_fields[1].value) <  50000))
        {
          IP_RULE_MSG("serevr=wait\n");
          return route_to("wait", NON_STICKY, saddr);
	}

R6:	if(strstr(url, "cs522") != NULL)
        {
          IP_RULE_MSG("server=wait\n");
          return route_to("wait", NON_STICKY, saddr);
	}

R7:	if(strstr(url, "ACE") != NULL)
        {
          IP_RULE_MSG("server=ace\n");
          return route_to("ace", NON_STICKY, saddr);
	}

R8:	if(strstr(url, "FRODO") != NULL)
        {
          IP_RULE_MSG("server=wait\n");
          return route_to("wait", NON_STICKY, saddr);
	}

R9:	if(strstr(url, "cs622") != NULL)
        {
          IP_RULE_MSG("server=wait\n");
          return route_to("wait", NON_STICKY, saddr);
	}

R9a:	if(strstr(url, "lcs1/tmp") != NULL)
        {
          IP_RULE_MSG("server=wait\n");
          return route_to("wait", NON_STICKY, saddr);
	}


R10:	if(strstr(url, "lcs1") != NULL)
        {
          IP_RULE_MSG("server=ace\n");
          return route_to("ace", NON_STICKY, saddr);
	}

R11:	if(strstr(url, "lcs2") != NULL)
        {
          IP_RULE_MSG("server=wait\n");
          return route_to("wait", NON_STICKY, saddr);
	}

R12:	if(strstr(url, "cprakash") != NULL)
        {
          IP_RULE_MSG("server=ace\n");
          return route_to("ace", NON_STICKY, saddr);
	}


  return route_to("default", NON_STICKY, saddr);
}
